﻿namespace Wzorce
{
    class Log //wzorzec singleton
    {
        private static Log? instancja = null;

        //leniwa inicjacja
        public static Log Instancja
        { 
            get 
            {
                if (instancja == null) instancja = new Log();
                return instancja;
            } 
        }

        private Log()
        {
            Console.WriteLine("Rejestr zdarzeń został utworzony");
        }

        private List<string> komunikaty = new List<string>();

        public void Dodaj(string komunikat)
        {
            komunikaty.Add(DateTime.Now.ToString() + " " + komunikat);
        }

        private const string nazwaPliku = "log.txt";

        public void Zapisz()
        {
            System.IO.File.WriteAllLines(nazwaPliku, komunikaty);
        }
    }


    internal class Program
    {
        static void Main(string[] args)
        {
            Log.Instancja.Dodaj("Uruchomienie aplikacji");

            new DalekaKlasaGłębokoWBibliotekach().Cośtam();

            Log.Instancja.Dodaj("Zatrzymanie aplikacji");
            Log.Instancja.Zapisz();
        }
    }

    class DalekaKlasaGłębokoWBibliotekach
    {
        public void Cośtam()
        {
            Log.Instancja.Dodaj("Metoda Cośtam w dalekiej klasie");
        }
    }

}
